-- hytech input file

-- gas burner

-- from Hybrid workshop 93


var
     x,y: clock;
     t:stopwatch;

automaton gb
synclabs:;
initially leaking & t = 0 & x = 0 & y=0;

loc leaking: while x>=0 & y>=0 & t>=0 & x <=1 wait {dt=1}
   when True do {x' = 0} goto not_leaking;

loc not_leaking: while  x>=0 & y>=0 & t>=0  wait {dt=0}
   when x>=30 do {x' = 0} goto leaking;

end

var init_reg, final_reg, b_reachable, f_reachable: region;

init_reg := loc[gb] = leaking & x=0&t=0 & y=0;

final_reg :=  y>=60 & t >= 1/20 y;


-- forward reachability does not terminate
-- f_reachable := reach forward from init_reg endreach;

b_reachable := reach backward from final_reg endreach;

if empty( b_reachable & init_reg)
  then prints "System satisfies non-leaking duration property";
  else prints "System does not satisfy non-leaking duration property";
endif;
