/* basic routines common to C and C++ code */

#include "basic.h"

char *
str_preserve(char *str) {
  if (str) {
    char *p = (char *) malloc ( (strlen(str) + 1)* sizeof (char) );
    strcpy(p,str);
    return(p);
  }
  else {
    return (char *) NULL;
  }
}

enum directions
opp_dirn(enum directions dir) {
  if (dir == PRE) {
    return( POST);
  }
  else {
    /* dir == POST */
    return( PRE);
  }
}

void
my_pause(int k) {
  int i, j;
  float r = 0;
  for (i=0;i<1000*k;i++) 
    for (j=0;j<5000;j++) 
      r += i*j;
   
}

/* return index of string key in array arr, -1 if not found */
int
string_pos(char *key, char **arr, int size) {
  int found = 0; /* False */
  int i = 0;
  while (!found && (i<size)) {
    found = (strcmp(key, arr[i]) == 0);
    if (!found) i++;
  }
  if (!found) {
    return - 1;
  }
  else {
    return i;
  }
}

void
clear_array(int *arr, int nr_elts) {
   int i;
   for (i=0;i<nr_elts;i++) {
     arr[i] = 0;
   }
 }


void
print_array(int *arr, int nr) {
  int i;
  for (i=0;i<nr;i++) {
    printf("%d:%d ", i,arr[i]);
  }
  printf("\n");
}
